/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.utilities.FieldStats;

 import java.awt.CardLayout;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.utilities.FieldStats.FieldStatsShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class GUI extends javax.swing.JPanel
{

    private Parameters parameters;

    /**
     * Creates new form SliceUI
     */
    public GUI()
    {
        initComponents();
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p, boolean resetFully, boolean setRunButtonPending)
    {
        if (p.get(META_COMPONENT_NAMES).length > 0) {
            boolean maskOrTime = p.get(META_IS_HAS_MASK_OR_IS_TIME_DEPENDENT);
            if (p.get(META_IS_REGULAR_FIELD)) {
                regularFieldStatsPanel.setProperties(parameters, p.get(SELECTED_COMPONENT), p.get(LOG_SCALE), p.get(META_NAME), p.get(META_DIMS), p.get(META_EXTENDS), p.get(META_PHYS_EXTENDS), p.get(META_COMPONENT_NAMES), p.get(META_SCHEMA), p.get(META_HISTOGRAM), maskOrTime ? null : p.get(META_AVG_GRAD), maskOrTime ? null : p.get(META_STDDEV_GRAD), maskOrTime ? null : p.get(META_DERIV_HISTOGRAM), maskOrTime ? null : p.get(META_THR_HISTOGRAM));
                ((CardLayout) getLayout()).show(this, "regular");
            } else {
                irregularFieldStatsPanel.setProperties(parameters, p.get(SELECTED_COMPONENT), p.get(LOG_SCALE), p.get(META_NAME), p.get(META_NNODES), p.get(META_EXTENDS), p.get(META_PHYS_EXTENDS), p.get(META_COMPONENT_NAMES), p.get(META_SCHEMA), p.get(META_HISTOGRAM));
                ((CardLayout) getLayout()).show(this, "irregular");
            }
        } else {
            ((CardLayout) getLayout()).show(this, "empty");
        }
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT
     * modify this code. The content of this method is always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        regularFieldStatsPanel = new org.visnow.vn.lib.gui.RegularFieldStatsPanel();
        irregularFieldStatsPanel = new org.visnow.vn.lib.gui.IrregularFieldStatsPanel();
        emptyPanel = new javax.swing.JPanel();

        setLayout(new java.awt.CardLayout());
        add(regularFieldStatsPanel, "regular");
        add(irregularFieldStatsPanel, "irregular");
        add(emptyPanel, "empty");
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel emptyPanel;
    private org.visnow.vn.lib.gui.IrregularFieldStatsPanel irregularFieldStatsPanel;
    private org.visnow.vn.lib.gui.RegularFieldStatsPanel regularFieldStatsPanel;
    // End of variables declaration//GEN-END:variables
}
